/*
 * desklet.c or desklet.h
 * Transparent window widget
 *
 * Copyright (C) 2012 - Akash Rawal
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef COMMON_H_INSIDE
//desklet.c
#include "common.h"
#else
//desklet.h

#define FRAC(i, m) ((i) < 0 ? (m) - ((-(i) + 1) % (m)) - 1 : (i) % (m))

typedef struct
{
	GtkWindow parent;

	GdkWindow *root_window;
	gboolean rgba;

	GdkPixmap *wallpaper;
	GdkPixmap *trans_pix;

	GdkGC *bg_gc;
	GdkGC *alpha_gc;

	gint x;
	gint y;
	gint width;
	gint height;

	gboolean position_set;
	gboolean handle_gravity;
	gint d_x;
	gint d_y;
} Desklet;

typedef struct
{
	GtkWindowClass parent;
	
} DeskletClass;

//FILE_HEADER_SUBST:gobject_macro_gen DESKLET Desklet desklet
#define TYPE_DESKLET (desklet_get_type())
#define DESKLET(ptr) \
		(G_TYPE_CHECK_INSTANCE_CAST((ptr), TYPE_DESKLET, Desklet))
#define IS_DESKLET(ptr) \
		(G_TYPE_CHECK_INSTANCE_TYPE((ptr), TYPE_DESKLET))
#define DESKLET_CLASS(ptr) \
		(G_TYPE_CHECK_CLASS_CAST((ptr), TYPE_DESKLET, DeskletClass))
#define IS_DESKLET_CLASS(ptr) \
		(G_TYPE_CHECK_CLASS_TYPE((ptr), TYPE_DESKLET))
#define DESKLET_GET_CLASS(ptr) \
		(G_TYPE_INSTANCE_GET_CLASS((ptr), TYPE_DESKLET, DeskletClass))
#define DESKLET_NAME "Desklet"

#endif //COMMON_H_INSIDE

/*Everything beyond this is automatically generated*/
void desklet_unset_position(Desklet *self);
void desklet_set_position(Desklet *self,gint x,gint y);
void desklet_make_rgba_trans(Desklet *self);
void desklet_paint_fake_bg(Desklet *self);
void desklet_update_wallpaper(Desklet *self);
void desklet_position(Desklet *self);
gboolean desklet_check_window_moved(Desklet *self);
gboolean desklet_event_cb(Desklet *self,GdkEvent *event);
void desklet_composited_changed(GdkScreen *screen,Desklet *self);
GdkFilterReturn desklet_event_filter(XEvent *xevent,GdkEvent *event,Desklet *self);
GtkWidget *desklet_new();
void desklet_unrealize(GtkWidget *widget);
void desklet_realize(GtkWidget *widget);
gboolean desklet_expose(GtkWidget *widget,GdkEventExpose *expose_event);
#if !(!defined(COMMON_H_INSIDE))
GType desklet_get_type();
#endif
#if !defined(COMMON_H_INSIDE)
G_DEFINE_TYPE(Desklet,desklet,GTK_TYPE_WINDOW);
#endif
