/*
 * icon_view.c or icon_view.h
 * Desklet that displays icons on desktop
 *
 * Copyright (C) 2012 - Akash Rawal
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef COMMON_H_INSIDE
//icon_view.c
#include "common.h"
#else
//icon_view.h

typedef struct
{
	GObject parent;

	GVolumeMonitor *monitor;
	Settings *settings;
	gint changed;

	GtkWidget *desklet;
	GtkWidget *box;
} IconView;

typedef struct
{
	GObjectClass parent;

} IconViewClass;

//FILE_HEADER_SUBST:gobject_macro_gen ICON_VIEW IconView icon_view
#define TYPE_ICON_VIEW (icon_view_get_type())
#define ICON_VIEW(ptr) \
		(G_TYPE_CHECK_INSTANCE_CAST((ptr), TYPE_ICON_VIEW, IconView))
#define IS_ICON_VIEW(ptr) \
		(G_TYPE_CHECK_INSTANCE_TYPE((ptr), TYPE_ICON_VIEW))
#define ICON_VIEW_CLASS(ptr) \
		(G_TYPE_CHECK_CLASS_CAST((ptr), TYPE_ICON_VIEW, IconViewClass))
#define IS_ICON_VIEW_CLASS(ptr) \
		(G_TYPE_CHECK_CLASS_TYPE((ptr), TYPE_ICON_VIEW))
#define ICON_VIEW_GET_CLASS(ptr) \
		(G_TYPE_INSTANCE_GET_CLASS((ptr), TYPE_ICON_VIEW, IconViewClass))
#define ICON_VIEW_NAME "IconView"

#endif

/*Everything beyond this is automatically generated*/
gboolean icon_view_changed_timeout(IconView *self);
void icon_view_changed(IconView *self,gint hint);
void icon_view_add_icon(IconView *self,GVolume *volume);
void icon_view_create_desklet(IconView *self);
#if !(!defined(COMMON_H_INSIDE))
GType icon_view_get_type();
#endif
#if !defined(COMMON_H_INSIDE)
G_DEFINE_TYPE(IconView,icon_view,G_TYPE_OBJECT);
#endif
